function love.load()
  
  io.stdout:setvbuf("no")
  
  m = 50
  newm = "50"
  lg = love.graphics
  
  rect = {-8,0,1,3,3}
  dot = lg.newImage("dot.png")
  cam = {1,1,0,1,1}
  cam[1],cam[2] = 800/2,600/2
  
  utf8 = require("utf8")
  
  lk = love.keyboard
  lk.setKeyRepeat(true)
  
  camChange = false
  
  instrucTime = os.clock()+8
  
end

function love.update(dt)
  
  gdt = dt
  
  rectSpeed = .1
  
  nx=0
  ny=0
  
  if newm == "" then
    newm = "0"
  end
  
end

function love.draw()
  
  local x,y,z,w,h = unpack(rect)
  local cx,cy,cr,csx,csy = unpack(cam)
  
  if z < 1 then
    lg.setColor(120,80,80, 120)
    lg.draw(dot, (x*m)+cx , (y*m)+cy , 0 , (w*m)+csx , (h*m)+csy )
    lg.setColor(80,80,120, 120)
    lg.draw(dot, ((x * m)/z) + cx , ((y * m)/z) + cy , 0 , ((w * m)/z) + csx , ((h * m)/z) + csy)
  else
    lg.setColor(80,80,120, 120)
    lg.draw(dot, ((x * m)/z) + cx , ((y * m)/z) + cy , 0 , ((w * m)/z) + csx , ((h * m)/z) + csy)
    lg.setColor(120,80,80, 120)
    lg.draw(dot, (x*m)+cx , (y*m)+cy , 0 , (w*m)+csx , (h*m)+csy )
  end
  
  lg.setColor(15,210,15)
  lg.line( (((x * m)/z) + cx) , (((y * m)/z) + cy)  ,  (x*m)+cx,(y*m)+cy)
  
  lg.line( ((((x*m)+(w*m))/z)+cx)+csx , ((((y*m)+(w*m))/z)+cy)+csy  ,  (((x*m)+(w*m))+cx)+csx,(((y*m)+(w*m)+cy)+csy))
  lg.setColor(230,230,230)
  if instrucTime >= os.clock() then
    lg.print("Use backspace and keys from 1-0 to change the meter", 110, 180)
    lg.print("Usa the arrow keys to change the position of the camera", 110, 40)
    lg.print("Use WASD to move the square", 110, 60)
    lg.print("Use + and - to move the square through Z", 110, 80)
    lg.print("The red square is a representation of the square if it were at z=1", 110, 100)
    lg.print("The z axis is inverted because I used the division method.", 110, 120)
    lg.print("i.e.: (x ó y*meter)/z", 110, 140)
    lg.print("Press 'r' to reset all values", 110, 160)
    lg.print("Press tab to make the instructions appear", 110, 20)
  end
  
  lg.print(string.format("Camera|| x: %d, y: %d, rotation: %d, scale x: %d, scale y: %d", unpack(cam)), 220, 500)
  lg.print(string.format("x: %gm, y: %gm, z: %g, Width: %gm, Height: %gm",x,y,z,w,h),220,520)
  lg.print(string.format("1 meter = %d pixels",m), 220, 540)
  lg.print(string.format("New meter: %d, press enter to apply.",newm), 220, 560)
  lg.print("-By: DiegoG", 220, 580)
  
  lg.setColor(15,15,210)
  
  lg.line(0,600/2,800,600/2)
  local i = 0
  local thing = true
  while nx < 800 do
    
    lg.line(nx,(600/2)+10 , nx,(600/2)-10)
    if thing then
      lg.print(string.format("%dm", i), nx,(600/2)+20)
      lg.print(string.format("%dp", nx), nx,(600/2)+30)
    else
      lg.print(string.format("%dm", i), nx,(600/2)-20)
      lg.print(string.format("%dp", nx), nx,(600/2)-30)
    end
    
    if thing then thing = false else thing = true end
    
    nx = nx + m
    i = i + 1
    
  end
  
  i = 0
  
  lg.setColor(210,15,15)
  
  lg.line(1,0 , 1,600)
  
  while ny < 600 do
    
    lg.line(0,ny , 20,ny)
    local str = string.format("%dm | %dp", i, ny)
    lg.print(str, 45, ny-15)
    
    ny = ny + m
    i = i + 1
    
  end
  
end

function love.keypressed(k)
  
  if k == "backspace" then
    local byteoffset = utf8.offset(newm, -1)
    
    if byteoffset then
      newm = string.sub(newm, 1, byteoffset - 1)
    end
    
  elseif k == "return" then
    
    m = tonumber(newm)
    newm = "50"
    rect = {0,0,1,3,3}
    
  end
  
  if lk.isDown("up") then
    cam[2] = cam[2] - 1
  end
  if lk.isDown("down") then
    cam[2] = cam[2] + 1
  end
  if lk.isDown("left") then
    cam[1] = cam[1] - 1
  end
  if lk.isDown("right") then
    cam[1] = cam[1] + 1
  end
  
  if lk.isDown("w") then
    rect[2] = rect[2] - rectSpeed
  end
  if lk.isDown("s") then
    rect[2] = rect[2] + rectSpeed
  end
  if lk.isDown("a") then
    rect[1] = rect[1] - rectSpeed
  end
  if lk.isDown("d") then
    rect[1] = rect[1] + rectSpeed
  end
  
  if lk.isDown("+") or lk.isDown("kp+") then
    rect[3] = rect[3] - .01
  end
  if lk.isDown("-") or lk.isDown("kp-") then
    rect[3] = rect[3] + .01
  end
  
  if k == "r" then love.load() end
  if k == "tab" then instrucTime = os.clock()+5 end
  
end

function love.textinput(t)
  
  local tn = tonumber(t)
  
  if tn then
    newm = newm..t
  end
  
end